/////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2004 Xilinx, Inc. All Rights Reserved.
//
// You may copy and modify these files for your own internal use solely with
// Xilinx programmable logic devices and  Xilinx EDK system or create IP
// modules solely for Xilinx programmable logic devices and Xilinx EDK system.
// No rights are granted to distribute any files unless they are distributed in
// Xilinx programmable logic devices.
//
// Modified by: Vlastimil Kosar, <ikosar@fit.vutbr.cz>
/////////////////////////////////////////////////////////////////////////////////

/* Note: This file depends on the following files having been included prior to self being included.
   1. portab.h
*/

#ifndef BL_SREC_H
#define BL_SREC_H

#define SREC_MAX_BYTES        255  /* Maximum record length */
#define SREC_DATA_MAX_BYTES   123  /* Maximum of 123 data bytes */

#define SREC_TYPE_0  0
#define SREC_TYPE_1  1
#define SREC_TYPE_2  2
#define SREC_TYPE_3  3
#define SREC_TYPE_5  5
#define SREC_TYPE_7  7
#define SREC_TYPE_8  8
#define SREC_TYPE_9  9

#define NO_EXTENDED_INFO 0
#define LINUX_ADDRESSES 1
#define LINUX_CMD_LINE 2

typedef struct srec_info_s {
    int8_t    type;
    uint8_t*  addr;
    uint8_t*  addr_FDTB;
    uint8_t*  addr_initramfs;
    int8_t    s0_info_type;
    uint8_t*  sr_data;
    uint8_t   dlen;
} srec_info_t;

/*
 * Gets SREC line from srec_fifo and decode it.
 * Params:
 *   srec_fifo - SREC fifo structure
 *   address   - addresses information block
 * Returns: 0 if error occured.
 *          1 if all is OK.
 *          2 if address was loaded
 */
uint32_t process_srec_line(t_fifo *srec_fifo, t_run_info *address);

#endif /* BL_SREC_H */
